﻿Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient
Imports Microsoft.Reporting.WebForms
Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            gvCustomers.DataSource = GetData("SELECT TOP 5 * FROM Customers ORDER BY NEWID()")
            gvCustomers.DataBind()
        End If
    End Sub

    Private Function GetData(query As String) As DataTable
        Dim conString As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Dim cmd As New SqlCommand(query)
        Using con As New SqlConnection(conString)
            Using sda As New SqlDataAdapter()
                cmd.Connection = con

                sda.SelectCommand = cmd
                Using dt As New DataTable()
                    sda.Fill(dt)
                    Return dt
                End Using
            End Using
        End Using
    End Function

    Protected Sub ShowRDLC(sender As Object, e As EventArgs)
        Dim dsCustomers As New Customers()
        For Each row As GridViewRow In gvCustomers.Rows
            If TryCast(row.FindControl("chkSelect"), CheckBox).Checked Then
                Dim customerId As String = row.Cells(1).Text
                Dim contactName As String = row.Cells(2).Text
                Dim city As String = row.Cells(3).Text
                Dim country As String = row.Cells(4).Text
                dsCustomers.Tables(0).Rows.Add(row.Cells(1).Text, row.Cells(2).Text, row.Cells(3).Text, row.Cells(4).Text)
            End If
        Next

        ReportViewer1.ProcessingMode = ProcessingMode.Local
        ReportViewer1.LocalReport.ReportPath = Server.MapPath("~/Report.rdlc")
        Dim datasource As New ReportDataSource("Customers", dsCustomers.Tables(0))
        ReportViewer1.LocalReport.DataSources.Clear()
        ReportViewer1.LocalReport.DataSources.Add(datasource)
    End Sub
End Class
